/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   SELOR - Servidor de Emails Livre Orientado a Regras                           
   Programado por Lucas Priori                                                   
                                                                                 
   Linux - make linux                                                            
       or  make linux_nocap                                                      
   FreeBSD - gmake freebsd                                                       
                                                                                 
  *******************************************************************            
  Selor e um agente MTA para troca de emails via protocolo SMTP                 
  Copyright (C) 2012,2013,2014,2015  Lucas Priori                                
                                                                                 
  This program is free software; you can redistribute it and/or                  
  modify it under the terms of the GNU General Public License                    
  as published by the Free Software Foundation; either version 2                 
  of the License, or (at your option) any later version.                         
                                                                                 
  This program is distributed in the hope that it will be useful,                
  but WITHOUT ANY WARRANTY; without even the implied warranty of                 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  
  GNU General Public License for more details.                                   
                                                                                 
  You should have received a copy of the GNU General Public License              
  along with this program; if not, write to the Free Software                    
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<arpa/nameser.h>
#include<arpa/inet.h>
#include<time.h>

#include "inc/global.h"
#include "inc/selor_utils.h"
#include "inc/selor_dns.h"
#include "inc/selor_mod.h"

#define MAX_itens 30
#define MAX_recursividade 10
#define CMD_STOP 1        // Comando que parar completamente o processando de todas os arquivos de regras  
#define CMD_EXIT 2        // Comando para sair apenas do atual arquivo de regras                           

//--- Variaveis 'Globais Locais' ---
char buffer_local2[TAM_buffer + 10];
char linha_local2[TAM_buffer + 10];
char nome_arq_regras[200];
unsigned short num_recursividade=0;
char byte=0;
FILE *exec_proc;


//======================================================
// Funcao que executa uma regra                         
// Retornos:                                            
// 0 = Processado com sucesso                           
// 1 = Processamento deve ser interrompido              
int exec_regras(char *regra, FILE *arq_regra, struct dados_email *str_from, struct dados_email *str_to){
 FILE *novo_arq, *arq_tmp;
 struct cpl_struct arq_handler;
 static void *fmap[256]={
 // 0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F        
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // 0
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // 1
  &&e, &&n, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&Inc, // 2
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // 3
  &&e, &&A, &&B, &&C, &&D, &&E, &&F, &&G, &&H, &&I, &&J, &&K, &&L, &&M, &&N, &&O,   // 4
  &&P, &&Q, &&R, &&S, &&T, &&U, &&V, &&W, &&X, &&Y, &&Z, &&e, &&e, &&e, &&e, &&e,   // 5
  &&e, &&A, &&B, &&C, &&D, &&E, &&F, &&G, &&H, &&I, &&J, &&K, &&L, &&M, &&N, &&O,   // 6
  &&P, &&Q, &&R, &&S, &&T, &&U, &&V, &&W, &&X, &&Y, &&Z, &&e, &&e, &&e, &&e, &&e,   // 7
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // 8
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // 9
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // A
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // B
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // C
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // D
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e,   // E
  &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e, &&e    // F
 };
 char buffer_local[TAM_buffer];
 char linha_local[TAM_buffer];
 char negador;
 char temp_local1=0;
 char *fim_regras;
 char *ptr_itens[MAX_itens];
 char *ptr_aux1;
 char *ptr_aux2;
 char *ptr_aux3;
 char *ptr_regra=linha_local;
 char *ptr_fim_regra=linha_local+TAM_buffer;
 char prim_byte=1;
 char aspas=0;
 char var=0;
 char ret=0;
 char muitos_itens=0;
 char modo_comentario=0;
 int ret_op=0;
 int b_lidos=0;
 int b_lidos2=0;
 unsigned int cont1=0;
 unsigned int temp1=0;
 unsigned int temp2=0;
 unsigned int num_itens=0;
 unsigned int conds=0;
 unsigned int conds_validas=0;
 
 linha_local[0]=0;      //Zerada aqui para o Compilador nao usar memset
 R_DENY=0;
 R_REPLY[0]=0;
 if(!arq_regra){
  selor_strncpy(nome_arq_regras, regra, sizeof(nome_arq_regras)-1);
  nome_arq_regras[sizeof(nome_arq_regras)-4]='.';
  nome_arq_regras[sizeof(nome_arq_regras)-3]='.';
  nome_arq_regras[sizeof(nome_arq_regras)-2]='.';
  nome_arq_regras[sizeof(nome_arq_regras)-1]=0;
  cont1=strlen(regra);
  fim_regras=regra+cont1;
  if(fim_regras[-1] != 10){
   // Acrescentando \10 no final do nome do arquivo de regras para a deteccao
   // do \10 funcionar no loop abaixo
   *(fim_regras++)=10;
   *fim_regras=0;
  }
  goto Proc_regra;
 }
 
 do{
  b_lidos=fread(&buffer_local, 1, TAM_buffer, arq_regra);
  regra=buffer_local;
  fim_regras=regra+b_lidos;
  if(b_lidos < TAM_buffer){
   // Caso o buffer lido seja menor que TAM_buffer
   // Vamos forcar um ENTER na ultima linha       
   *(fim_regras++)=10;
   *fim_regras=0;
  }
  Proc_regra:
  while(!ret && regra < fim_regras){
   if(*regra == 10){
    // Processando linha de regras
    *ptr_regra=0;
    ptr_regra=linha_local;
    conds=conds_validas=0;
    delimiter=':';            // Resetando o Delimitador
    if(!muitos_itens){
     for(cont1=0; conds==conds_validas && cont1<num_itens; cont1++){
      negador=0;
      goto *fmap[(int)ptr_itens[cont1][0] & 0xFF];
      n:
       negador=1;
       ptr_itens[cont1]++;
       goto *fmap[(int)ptr_itens[cont1][0] & 0xFF];
       
      A:
       // == Auth ==
       if(!cmp_str_vars(ptr_itens[cont1], "Auth?")){
        conds++;
        if(host.autenticado^negador)conds_validas++;
       
       // == Add_hits ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Add_hits!")){
        if(++cont1 >= num_itens)continue;
        R_HITS+=atoi(ptr_itens[cont1]);
       
       // == Accept ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Accept!")){
        R_ACCEPT=1;
        ret=CMD_STOP;
        num_smtp_resp=MSG_ok;
       }else goto e;
       continue;
      
      B:
       goto e;
       
      C:
       // == Close ==
       if(!cmp_str_vars(ptr_itens[cont1], "Close!")){
        R_CLOSE=1;
        ret=CMD_STOP;
        close(socket_remoto);
        
       // == Cp ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Cp!")){
        if(++cont1 >= num_itens)continue;
        if(prox_num_rcpt < DEF_max_rcpts){
         for(temp1=0; temp1<prox_num_rcpt; temp1++)if(!strcmp(to[temp1].email, ptr_itens[cont1]))break;
         if(temp1 == prox_num_rcpt){
          smtp_dados_email(ptr_itens[cont1], &to[prox_num_rcpt], NULL);
          to[prox_num_rcpt].status=' ';
          to[prox_num_rcpt].local=-1;        //Marcando como indefinido para resolver depois
          prox_num_rcpt++;
         }
        }else {
         R_DENY=1;
         ret=CMD_STOP;
         num_smtp_resp=MSG_toomany_rcpts;
        }
        
       // == Cmp_str ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Cmp_str?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        if((!cmp_str_vars(ptr_itens[cont1], ptr_aux1))^negador)conds_validas++;
       
       // == Cmp_left ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Cmp_left?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        temp1=strlen(ptr_aux1);
        if(!temp1)conds_validas++;
        else if((!cmp_str(ptr_itens[cont1], ptr_aux1, temp1))^negador)conds_validas++;
       
       // == Cmp_right ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Cmp_right?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        temp1=strlen(ptr_itens[cont1]);
        temp2=strlen(ptr_aux1);
        if(temp1 >= temp2)if((!cmp_str_vars(&ptr_itens[cont1][temp1-temp2], ptr_aux1))^negador)conds_validas++;
        
       // == Cmp_reverse ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Cmp_reverse?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((!cmp_str_vars(ptr_itens[cont1], host.nome))^negador)conds_validas++;
       }else goto e;
       continue;
       
      D:
       // == Deny ==
       if(!cmp_str_vars(ptr_itens[cont1], "Deny!")){
        R_DENY=1;
        ret=CMD_STOP;
        num_smtp_resp=MSG_refused;
       
       // == Def ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Def!")){
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], ' ')))continue;
        *ptr_aux1++=0;
        ptr_aux1=pular_carac(ptr_aux1, ' ');
        if(*ptr_aux1 == '\''){
         ptr_aux1++;
         if((ptr_aux2=strchr(ptr_aux1, '\'')))*ptr_aux2=0;
        }
        if((ret_op=def_parametro(ptr_itens[cont1], ptr_aux1)) >=0)def_ops[num_ops++]=ret_op;
        
       
       // == Data_reply ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Data_reply!")){
        if(++cont1 >= num_itens)continue;
        //selor_superstrncpy(R_DATA_REPLY, TAM_defs-3, ptr_itens[cont1], "\r\n", NULL);
        temp1=selor_strncpy(R_DATA_REPLY, ptr_itens[cont1], TAM_defs-3);
        R_DATA_REPLY[temp1++]='\r';
        R_DATA_REPLY[temp1++]='\n';
        R_DATA_REPLY[temp1]=0;
        
       // == Delimiter ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Delimiter!")){
        if(++cont1 >= num_itens)continue;
        delimiter=ptr_itens[cont1][0];
        
       }else goto e;
       continue;
       
      E:
       // == Exit ==
       if(!cmp_str_vars(ptr_itens[cont1], "Exit!")){
        ret=CMD_EXIT;
       
       // == Exec ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Exec!")){
        if(++cont1 >= num_itens)continue;
        if(!(exec_proc=popen(ptr_itens[cont1], "r")))continue;
        temp1=fread(&R_EXEC_STR, 1, TAM_exec_str, exec_proc);
        R_EXEC=pclose(exec_proc) >> 8;
        if(temp1 > 0){
         if(R_EXEC_STR[temp1-1] == '\n')temp1--;
         if(temp1 && R_EXEC_STR[temp1-1] == '\r')temp1--;
        }
        if(temp1 >= 0)R_EXEC_STR[temp1]=0;
        
       // == Exec_resp ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Exec_resp?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((atoi(ptr_itens[cont1]) == R_EXEC)^negador)conds_validas++;
       }else goto e;
       continue;
       
      F:
       // == From ==
       if(!cmp_str_vars(ptr_itens[cont1], "From?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((!cmp_str_vars(ptr_itens[cont1], str_from->email))^negador)conds_validas++;
        
       // == Find_in_from ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Find_in_from?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((proc_str(str_from->email, ptr_itens[cont1]) != NULL)^negador)conds_validas++;
        
       // == Find_in_to ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Find_in_to?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((proc_str(str_to->email, ptr_itens[cont1]) != NULL)^negador)conds_validas++;
        
       // == Find_str ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Find_str?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        if((proc_str(ptr_itens[cont1], ptr_aux1) != NULL)^negador)conds_validas++;
        
       // == Find_in_reverse ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Find_in_reverse?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((proc_str(host.nome, ptr_itens[cont1]) != NULL)^negador)conds_validas++;
       
       // == Find_strfile ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Find_strfile?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        temp_local1=0;
        if((arq_tmp=fopen(ptr_aux1, "rb"))){
         arq_handler.dest=linha_local2;
         arq_handler.tambuffer=arq_handler.tamusado=TAM_buffer;
         while(!feof(arq_tmp)){
          b_lidos2=fread(&buffer_local2, 1, TAM_buffer, arq_tmp);
          buffer_local2[b_lidos2]=0;
          arq_handler.orig=buffer_local2;
          while(!cpl(&arq_handler)){
           arq_handler.dest=linha_local2;
           if(proc_str(ptr_itens[cont1], linha_local2)){
            temp_local1=1;
            goto Find_strfile_achado;
           }
          }
         }
         fclose(arq_tmp);
        }
        Find_strfile_achado:
        if(temp_local1^negador)conds_validas++;
       
       // == Find_filestr ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Find_filestr?") || !cmp_str_vars(ptr_itens[cont1], "Find_fileline?")){
        conds++;
        temp2=ptr_itens[cont1][13] == '?';
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        temp_local1=0;
        if((arq_tmp=fopen(ptr_itens[cont1], "rb"))){
         arq_handler.dest=linha_local2;
         arq_handler.tambuffer=arq_handler.tamusado=TAM_buffer;
         while(!feof(arq_tmp)){
          b_lidos2=fread(buffer_local2, 1, TAM_buffer, arq_tmp);
          buffer_local2[b_lidos2]=0;
          arq_handler.orig=buffer_local2;
          while(!cpl(&arq_handler)){
           arq_handler.dest=linha_local2;
           if(!temp2){
            if(proc_str(linha_local2, ptr_aux1)){
             temp_local1=1;
             goto Find_filestr_achado;
            }
           }else if(!cmp_str_vars(linha_local2, ptr_aux1)){
            temp_local1=1;
            goto Find_filestr_achado;
           }
          }
         }
         fclose(arq_tmp);
        }
        Find_filestr_achado:
        if(temp_local1^negador)conds_validas++;
        
       // == Find_in_reverse ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Fchange!")){
        if(++cont1 >= num_itens)continue;
        smtp_dados_email(ptr_itens[cont1], str_from, NULL);
        if(cache_mod_dom_local(str_from->dominio, adomain, &temp1) == 1)str_from->local=1;
        else str_from->local=0;
       
       // == From_type ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "From_type?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((atoi(ptr_itens[cont1]) == R_FROM_TYPE)^negador)conds_validas++;
       
       
       }else goto e;
       continue;
      
      G:
       goto e;
      
      H:
       // == Helo ==
       if(!cmp_str_vars(ptr_itens[cont1], "Helo?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((!cmp_str_vars(ptr_itens[cont1], host.helo))^negador)conds_validas++;
       
       // == Hadd ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Hadd!")){
        if(++cont1 >= num_itens)continue;
        if(R_TAM_HADD < TAM_hadd){
         selor_strncat(R_HADD, ptr_itens[cont1], TAM_hadd-R_TAM_HADD-1);
         R_TAM_HADD=selor_strncat(R_HADD, "\n", TAM_hadd-R_TAM_HADD);
        }
       }else goto e;
       continue;
       
      I:
       // == IP ==
       if(!cmp_str_vars(ptr_itens[cont1], "Ip?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((ptr_aux1=strchr(ptr_itens[cont1], '/'))){
         *ptr_aux1++=0;
         temp_local1=atoi(ptr_aux1);
        }else temp_local1=32;
        temp1=inet_addr(ptr_itens[cont1]);
        if((tmasc(host.ipn, temp1, temp_local1))^negador)conds_validas++;
       
       // == Internal_from ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Internal_from?")){
        conds++;
        if(str_from->local^negador)conds_validas++;
       
       // == Internal_from ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Internal_rcpt?")){
        conds++;
        if(str_to->local^negador)conds_validas++;
       
       // == Itest ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Itest?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((ptr_aux1=strchr(ptr_itens[cont1], '='))){
         *ptr_aux1++=0;
         if((atoi(ptr_itens[cont1]) == atoi(ptr_aux1))^negador)conds_validas++;
        }else if((ptr_aux1=strchr(ptr_itens[cont1], '<'))){
         *ptr_aux1++=0;
         if((atoi(ptr_itens[cont1]) < atoi(ptr_aux1))^negador)conds_validas++;
        }else if((ptr_aux1=strchr(ptr_itens[cont1], '>'))){
         *ptr_aux1++=0;
         if((atoi(ptr_itens[cont1]) > atoi(ptr_aux1))^negador)conds_validas++;
        }
        
       // == Inc_rules ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Inc_rules!")){
        if(++cont1 >= num_itens)continue;
        Inc:
        if(num_recursividade >= MAX_recursividade){
         selor_superstrncpy(buffer_log, TAM_buffer_log, "Maximum level of Inc_rules has been reached to file:", ptr_itens[cont1], "\n", NULL);
         log_msg(DEF_warning_log);
         continue;
        }
        if(!(novo_arq=fopen(ptr_itens[cont1], "rb")))continue;
        ret=exec_regras(NULL, novo_arq, str_from, str_to);
        fclose(novo_arq);
        
       }else goto e;
       continue;
      
      J:
       goto e;
      
      K:
       goto e;
      
      L:
       // == Log ==
       if(!cmp_str_vars(ptr_itens[cont1], "Log!")){
        if(++cont1 >= num_itens)continue;
        if(!(ptr_aux1=strchr(ptr_itens[cont1], delimiter)))continue;
        *ptr_aux1++=0;
        selor_superstrncpy(buffer_log, TAM_buffer_log, ptr_aux1, "\n", NULL);
        log_msg(ptr_itens[cont1]);
       }else goto e;
       continue;
      
      M:
       // == Mx_dest ==
       if(!cmp_str_vars(ptr_itens[cont1], "Mx_dest!")){
        if(++cont1 >= num_itens)continue;
        selor_strncpy(str_to->dest, ptr_itens[cont1], TAM_email_dest);
       
       // == Mx_auth ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Mx_auth!")){
        if(++cont1 >= num_itens)continue;
        selor_strncpy(str_to->auth, ptr_itens[cont1], TAM_email_auth);
        str_to->pass=strchr(str_to->auth, ' ');
        if(!str_to->pass && (str_to->pass=strchr(str_to->auth, delimiter)))*str_to->pass=' ';
       
       // == Mx_source ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Mx_source!")){
        if(++cont1 >= num_itens)continue;
        selor_strncpy(str_to->mx_source, ptr_itens[cont1], NS_MAXDNAME);
        
       // == Mark ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Mark!")){
        if(++cont1 >= num_itens)continue;
        selor_strncpy(R_MARK, ptr_itens[cont1], TAM_mark);
       }else goto e;
       continue;

      N:
       goto e;
      
      O:
       goto e;
      
      P:
       // == Proc_rules ==
       if(!cmp_str_vars(ptr_itens[cont1], "Proc_rules!")){
        if(++cont1 >= num_itens)continue;
        if(!(novo_arq=fopen(ptr_itens[cont1], "rb")))continue;
        exec_regras(NULL, novo_arq, str_from, str_to);
        fclose(novo_arq);
        ret=CMD_STOP;
       }else goto e;
       continue;
       
      Q:
       // == Qlimit ==
       if(!cmp_str_vars(ptr_itens[cont1], "Qlimit!")){
        strcpy(R_DSPOOL, "qlimit");
        DEF_immed_delivery=0;
       }else goto e;
       continue;
      
      R:
       // == Reply ==
       if(!cmp_str_vars(ptr_itens[cont1], "Reply!")){
        if(++cont1 >= num_itens)continue;
        //temp1=selor_superstrncpy(R_REPLY, TAM_defs-3, ptr_itens[cont1], "\r\n", NULL);
        temp1=selor_strncpy(R_REPLY, ptr_itens[cont1], TAM_defs-3);
        R_REPLY[temp1++]='\r';
        R_REPLY[temp1++]='\n';
        R_REPLY[temp1]=0;
        temp1=selor_send(socket_remoto, R_REPLY, temp1, 0);
        if(R_REPLY[0] != '2' && R_REPLY[0] != '3')R_DENY=1;
        ret=CMD_STOP;
       
       // == Relay ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Relay!")){
        R_RELAY=2;
        
       // == Relay_denied ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Relay_denied!")){
        R_RELAY=0;
        R_ACCEPT&=0xFD;    // 0xFD -> Desativa o BIT 2 (Relay Accept) de R_ACCEPT
        if(!R_ACCEPT)num_smtp_resp=MSG_relay_denied;
        
       // == Rbl_resp ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Rbl_resp?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((atoi(ptr_itens[cont1]) == host.rbl)^negador)conds_validas++;
       
       // == Rbl_test ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Rbl_test!")){
        if(++cont1 >= num_itens)continue;
        host.rbl=rbl_check(host.ipn, ptr_itens[cont1], R_RBL_TXT, NS_MAXDNAME);
       
       // == Rev_fail ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Rev_fail?")){
        conds++;
        if(host.nome[0]){
         temp1=0;
         while((temp2=resolver_dom(host.nome, NULL, temp1))){
          temp1++;
          if(host.ipn == temp2)break;
         }
         if((temp2 != 0)^negador)conds_validas++;    //Se temp2 tiver um IP  porque foi encontrado
        }
       
       // == Resolve ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Resolve!")){
        reverso(host.ipn, host.nome, NS_MAXDNAME-1);
        host.strlen_nome=strlen(host.nome);
       }else goto e;
       continue;
       
      S:
       // == Stop ==
       if(!cmp_str_vars(ptr_itens[cont1], "Stop!")){
        ret=CMD_STOP;
       
       // == Spf_test ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Spf_test!")){
        R_SPF=spf_check(str_from->dominio, host.ipn);
        
       // == Spf_resp ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Spf_resp?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((atoi(ptr_itens[cont1]) == R_SPF)^negador)conds_validas++;
       
       // == Srs ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Srs!") && DEF_srs_key[0] && !srs_from[0]){
        if(++cont1 >= num_itens)continue;
        if((ptr_aux1=strchr(ptr_itens[cont1], '@')))ptr_aux1++;
        else ptr_aux1=ptr_itens[cont1];
        if(!*ptr_aux1)ptr_aux1=DEF_server_name;
        if(!srs_encode(buffer_local2, TAM_endereco, str_from->email, ptr_aux1, DEF_srs_key, DEF_srs_shift, tempo)){
         // -- SRS gerado com sucesso --
         smtp_dados_email(buffer_local2, str_from, NULL);
         if(cache_mod_dom_local(str_from->dominio, adomain, &temp1) == 1)str_from->local=1;
         else str_from->local=0;
        }
       
       // == Sendmail ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Sendmail!")){
        if(++cont1 >= num_itens)continue;
        if((ptr_aux1=strchr(ptr_itens[cont1], delimiter)))byte=delimiter;
        else if(!(ptr_aux1=strchr(ptr_itens[cont1], ' ')))continue;
        else byte=' ';
        *ptr_aux1++=0;
        if(!(ptr_aux2=strchr(ptr_aux1, byte)))continue;
        *ptr_aux2++=0;
        if((ptr_aux3=strchr(ptr_aux2, byte)))*ptr_aux3++=0;
        msg_queue(ptr_itens[cont1], ptr_aux1, ptr_aux2, ptr_aux3);     // Coloca a mensagem na fila do servidor
        
       // == So_mark ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "So_mark!")){
        if(++cont1 >= num_itens)continue;
        if(etapa_smtp <= ETAPA_mail_from)R_SO_MARK=atoi(ptr_itens[cont1]);
        else str_to->so_mark=atoi(ptr_itens[cont1]);
       
       // == Seek_to ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Seek_to?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        temp_local1=0;
        for(temp1=0; temp1<num_rcpt; temp1++){          // Buscando To na lista de rcpts
         if(!strcmp(to[temp1].email, ptr_itens[cont1])){
          temp_local1=1;
          break;
         }
        }
        if(temp_local1^negador)conds_validas++;
       
       // == Seek_in_to ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Seek_in_to?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        temp_local1=0;
        for(temp1=0; temp1<num_rcpt; temp1++){          // Buscando texto na lista de rcpts
         if(proc_str(to[temp1].email, ptr_itens[cont1]) != NULL){
          temp_local1=1;
          break;
         }
        }
        if(temp_local1^negador)conds_validas++;
       
       }else goto e;
       continue;
       
      T:
       // == To ==
       if(!cmp_str_vars(ptr_itens[cont1], "To?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((!cmp_str_vars(ptr_itens[cont1], str_to->email))^negador)conds_validas++;
       
       // == Tmark ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Tmark?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((!cmp_str_vars(ptr_itens[cont1], R_MARK))^negador)conds_validas++;
       
       // == Tchange ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "Tchange!")){
        if(++cont1 >= num_itens)continue;
        for(temp1=0; temp1<num_rcpt; temp1++)if(!strcmp(to[temp1].email, ptr_itens[cont1]))break;
        if(temp1 == num_rcpt){
         smtp_dados_email(ptr_itens[cont1], str_to, NULL);
         if(cache_mod_dom_local(str_to->dominio, adomain, &temp2) == 1)str_to->local=1;
         else str_to->local=0;
        }else prox_num_rcpt--;
        
       // == To_type ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "To_type?")){
        conds++;
        if(++cont1 >= num_itens)continue;
        if((atoi(ptr_itens[cont1]) == R_TO_TYPE)^negador)conds_validas++;
       
       // == To_over_quota ==
       }else if(!cmp_str_vars(ptr_itens[cont1], "To_over_quota?")){
        conds++;
        if(R_TO_OVER_QUOTA^negador)conds_validas++;
        
       }else goto e;
       continue;
      
      U:
       goto e;
      
      V:
       goto e;
      
      W:
       goto e;
      
      X:
       goto e;
      
      Y:
       goto e;
      
      Z:
       goto e;
      
      e:
       // === Comando nao reconhecido ===
       break;
     }
    }else {
     if(muitos_itens == 1)selor_superstrncpy(buffer_log, TAM_buffer_log, "WRN: The file [", nome_arq_regras,"] has a rule with many items and was ignored\n", NULL);
     else selor_superstrncpy(buffer_log, TAM_buffer_log, "WRN: The file [", nome_arq_regras,"] has a rule too big and was ignored\n", NULL);
     log_msg(DEF_warning_log);
     muitos_itens=0;
    }
    num_itens=aspas=0;
    prim_byte=1;
       
   
   
   // -- Separacao dos nomes das acoes/condicoes --
   }else if(!aspas && *regra == ' '){
    if(!prim_byte)*(ptr_regra++)=0;
    prim_byte=1;
   }else {
    if(prim_byte){
     prim_byte=0;
     if(*regra == '#' || modo_comentario){                // --> Para tratar comentarios
      while(*regra != 10 && regra < fim_regras)regra++;
      if(regra >= fim_regras)modo_comentario=prim_byte=1; // Linha de comentario caiu bem entre buffers. Precisamos tratar isso
      else modo_comentario=0;
      continue;             // Comentario. Ignorar o resto
     }
     if(num_itens >= MAX_itens){
      while(*regra != 10 && regra < fim_regras)regra++;
      if(regra >= fim_regras)prim_byte=1;    // Linha com muitos itens e entre buffers. Precisamos tratar isso
      muitos_itens=1;
      continue;
     }
     ptr_itens[num_itens++]=ptr_regra;
    }
    if(!var && *regra == '"')aspas=aspas^1;
    else {
     if(var){
      var=0;
      if(*regra == 'r')ptr_regra+=selor_strncpy(ptr_regra, str_to->email, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'f')ptr_regra+=selor_strncpy(ptr_regra, str_from->email, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'u')ptr_regra+=selor_strncpy(ptr_regra, auth_info.user, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'i')ptr_regra+=selor_strncpy(ptr_regra, host.ip, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'e')ptr_regra+=selor_strncpy(ptr_regra, host.nome, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 's'){
       if(host.nome[0])ptr_regra+=selor_strncpy(ptr_regra, host.nome, TAM_buffer - (ptr_regra-linha_local));
       else ptr_regra+=selor_strncpy(ptr_regra, host.ip, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'h')ptr_regra+=selor_strncpy(ptr_regra, host.helo, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'o'){
       if(str_from->dominio)ptr_regra+=selor_strncpy(ptr_regra, str_from->dominio, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'c'){
       if(str_to->dominio)ptr_regra+=selor_strncpy(ptr_regra, str_to->dominio, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'm'){
       if((ptr_aux1=strchr(str_from->email, '@'))){
        *ptr_aux1=0;
        ptr_regra+=selor_strncpy(ptr_regra, str_from->email, TAM_buffer - (ptr_regra-linha_local));
        *ptr_aux1='@';
       }else ptr_regra+=selor_strncpy(ptr_regra, str_from->email, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'p'){
       if((ptr_aux1=strchr(str_to->email, '@'))){
        *ptr_aux1=0;
        ptr_regra+=selor_strncpy(ptr_regra, str_to->email, TAM_buffer - (ptr_regra-linha_local));
        *ptr_aux1='@';
       }else ptr_regra+=selor_strncpy(ptr_regra, str_to->email, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'n')ptr_regra+=selor_strncpy(ptr_regra, itoa(num_rcpt, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'y')ptr_regra+=selor_strncpy(ptr_regra, itoa(R_SPF, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'H')ptr_regra+=selor_strncpy(ptr_regra, itoa(R_HITS, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 't')ptr_regra+=selor_strncpy(ptr_regra, itoa(R_EXEC, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'E'){
       ptr_aux1=R_EXEC_STR;
       //while(*ptr_aux1){
       // if(*ptr_aux1 == ':')*ptr_aux1=' ';          // --> Convertendo ':' em ' ' para nao interferir em Condicoes que usam o ':' como identificador de parametros
       // ptr_aux1++;
       //}
       ptr_regra+=selor_strncpy(ptr_regra, R_EXEC_STR, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'T'){
       ptr_aux1=R_RBL_TXT;
       while(*ptr_aux1){
        if(*ptr_aux1 == 13 || *ptr_aux1 == 10 || *ptr_aux1 == ':')*ptr_aux1=' ';          // --> Convertendo \r, \n e ':' em ' '. A conversao dos ':' e' para nao interferir em
                                                                                          //     Condicoes que usam ':' como separador de parametros                           
        ptr_aux1++;
       }
       ptr_regra+=selor_strncpy(ptr_regra, R_RBL_TXT, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'P'){
       ptr_aux1=R_SERVER_RESP;
       while(*ptr_aux1){
        if(*ptr_aux1 == 13 || *ptr_aux1 == 10 || *ptr_aux1 == ':')*ptr_aux1=' ';          // --> Convertendo \r, \n e ':' em ' '. A conversao dos ':' e' para nao interferir em
                                                                                          //     Condicoes que usam ':' como separador de parametros                           
        ptr_aux1++;
       }
       ptr_regra+=selor_strncpy(ptr_regra, R_SERVER_RESP, TAM_buffer - (ptr_regra-linha_local));
      }else if(*regra == 'd')ptr_regra+=selor_strncpy(ptr_regra, id_fila, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'z')ptr_regra+=selor_strncpy(ptr_regra, itoa(tam_email, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'C')ptr_regra+=selor_strncpy(ptr_regra, rcpt_info.home, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'F')ptr_regra+=selor_strncpy(ptr_regra, from_info.home, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'U')ptr_regra+=selor_strncpy(ptr_regra, auth_info.home, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'L')ptr_regra+=selor_strncpy(ptr_regra, cam_spool, TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'R')ptr_regra+=selor_strncpy(ptr_regra, itoa(host.rbl, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'O')ptr_regra+=selor_strncpy(ptr_regra, itoa(timeinfo->tm_hour, 2), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'M')ptr_regra+=selor_strncpy(ptr_regra, itoa(timeinfo->tm_min, 2), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'S')ptr_regra+=selor_strncpy(ptr_regra, itoa(timeinfo->tm_sec, 2), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'D')ptr_regra+=selor_strncpy(ptr_regra, itoa(timeinfo->tm_wday, 0), TAM_buffer - (ptr_regra-linha_local));
      else if(*regra == 'I')ptr_regra+=selor_strncpy(ptr_regra, from_dom_original, TAM_buffer - (ptr_regra-linha_local));
      else *(ptr_regra++)=*regra;
     }else {
      if(aspas && *regra == '%')var=1;
      else if(*regra != 13){
       if(ptr_regra >= ptr_fim_regra){
        muitos_itens=2;
        regra++;
        continue;
       }
       *(ptr_regra++)=*regra;
      }
     }
    }
   }
   regra++;
  }
 }while(!ret && arq_regra && !feof(arq_regra));
 if(ret == CMD_EXIT)return 0;
 return ret;
}






